// Generated by dts-bundle v0.7.3-fork.1
// Dependencies for this module:
//   ../../../../../@fullcalendar/core

declare module '@fullcalendar/daygrid' {
    import DayTableView from '@fullcalendar/daygrid/DayTableView';
    
    export { default as DayTable, DayTableSlicer } from '@fullcalendar/daygrid/DayTable';
    export { default as Table } from '@fullcalendar/daygrid/Table';
    export { default as TableSeg } from '@fullcalendar/daygrid/TableSeg';
    export { TableCellModel } from '@fullcalendar/daygrid/TableCell';
    export { default as TableView } from '@fullcalendar/daygrid/TableView';
    export { buildDayTableModel } from '@fullcalendar/daygrid/DayTableView';
    export { DayTableView as DayGridView };
    const _default: import("@fullcalendar/core").PluginDef;
    export default _default;
}

declare module '@fullcalendar/daygrid/DayTableView' {
    import { h, ComponentContext, DateProfileGenerator, DateProfile, ViewProps, DayTableModel } from '@fullcalendar/core';
    import TableView from '@fullcalendar/daygrid/TableView';
    export { DayTableView as default, DayTableView };
    class DayTableView extends TableView {
        render(props: ViewProps, state: {}, context: ComponentContext): h.JSX.Element;
    }
    export function buildDayTableModel(dateProfile: DateProfile, dateProfileGenerator: DateProfileGenerator): DayTableModel;
}

declare module '@fullcalendar/daygrid/DayTable' {
    import { h, VNode, DateProfile, EventStore, EventUiHash, DateSpan, EventInteractionState, DayTableModel, Duration, DateComponent, DateRange, Slicer, ComponentContext, RefObject, CssDimValue, Hit } from '@fullcalendar/core';
    import TableSeg from '@fullcalendar/daygrid/TableSeg';
    export interface DayTableProps {
        dateProfile: DateProfile;
        dayTableModel: DayTableModel;
        nextDayThreshold: Duration;
        businessHours: EventStore;
        eventStore: EventStore;
        eventUiBases: EventUiHash;
        dateSelection: DateSpan | null;
        eventSelection: string;
        eventDrag: EventInteractionState | null;
        eventResize: EventInteractionState | null;
        colGroupNode: VNode;
        tableMinWidth: CssDimValue;
        renderRowIntro?: () => VNode;
        dayMaxEvents: boolean | number;
        dayMaxEventRows: boolean | number;
        expandRows: boolean;
        showWeekNumbers: boolean;
        headerAlignElRef?: RefObject<HTMLElement>;
        clientWidth: number | null;
        clientHeight: number | null;
    }
    export { DayTable as default, DayTable };
    class DayTable extends DateComponent<DayTableProps, ComponentContext> {
        render(props: DayTableProps, state: {}, context: ComponentContext): h.JSX.Element;
        handleRootEl: (rootEl: HTMLDivElement) => void;
        prepareHits(): void;
        queryHit(positionLeft: number, positionTop: number): Hit;
    }
    export class DayTableSlicer extends Slicer<TableSeg, [DayTableModel]> {
        forceDayIfListItem: boolean;
        sliceRange(dateRange: DateRange, dayTableModel: DayTableModel): TableSeg[];
    }
}

declare module '@fullcalendar/daygrid/Table' {
    import { EventSegUiInteractionState, VNode, DateComponent, RefObject, CssDimValue, h, Ref, ComponentContext, DateProfile } from '@fullcalendar/core';
    import TableSeg from '@fullcalendar/daygrid/TableSeg';
    import { TableCellModel, MoreLinkArg } from '@fullcalendar/daygrid/TableCell';
    export interface TableProps {
        elRef?: Ref<HTMLDivElement>;
        cells: TableCellModel[][];
        dateProfile: DateProfile;
        renderRowIntro?: () => VNode;
        colGroupNode: VNode;
        tableMinWidth: CssDimValue;
        expandRows: boolean;
        showWeekNumbers: boolean;
        clientWidth: number | null;
        clientHeight: number | null;
        businessHourSegs: TableSeg[];
        bgEventSegs: TableSeg[];
        fgEventSegs: TableSeg[];
        dateSelectionSegs: TableSeg[];
        eventSelection: string;
        eventDrag: EventSegUiInteractionState | null;
        eventResize: EventSegUiInteractionState | null;
        dayMaxEvents: boolean | number;
        dayMaxEventRows: boolean | number;
        headerAlignElRef?: RefObject<HTMLElement>;
    }
    interface TableState {
        morePopoverState: MorePopoverState | null;
    }
    interface MorePopoverState extends MoreLinkArg {
        currentFgEventSegs: TableSeg[];
    }
    export { Table as default, Table };
    class Table extends DateComponent<TableProps, TableState> {
        render(props: TableProps, state: TableState, context: ComponentContext): h.JSX.Element;
        handleRootEl: (rootEl: HTMLElement) => void;
        handleMoreLinkClick: (arg: MoreLinkArg) => void;
        handleMorePopoverClose: () => void;
        prepareHits(): void;
        positionToHit(leftPosition: any, topPosition: any): {
            row: any;
            col: any;
            dateSpan: {
                range: {
                    start: Date;
                    end: Date;
                };
                allDay: boolean;
            };
            dayEl: HTMLTableCellElement;
            relativeRect: {
                left: any;
                right: any;
                top: any;
                bottom: any;
            };
        };
    }
    export {};
}

declare module '@fullcalendar/daygrid/TableSeg' {
    import { EventSegUiInteractionState, Seg } from '@fullcalendar/core';
    export default interface TableSeg extends Seg {
        row: number;
        firstCol: number;
        lastCol: number;
    }
    export function splitSegsByRow(segs: TableSeg[], rowCnt: number): TableSeg[][];
    export function splitSegsByFirstCol(segs: TableSeg[], colCnt: number): TableSeg[][];
    export function splitInteractionByRow(ui: EventSegUiInteractionState | null, rowCnt: number): EventSegUiInteractionState[];
}

declare module '@fullcalendar/daygrid/TableCell' {
    import { Ref, ComponentChildren, h, DateMarker, DateComponent, ComponentContext, CssDimValue, DateProfile, DateRange } from '@fullcalendar/core';
    import TableSeg from '@fullcalendar/daygrid/TableSeg';
    export interface TableCellProps {
        date: DateMarker;
        extraHookProps?: object;
        extraDataAttrs?: object;
        extraClassNames?: string[];
        elRef?: Ref<HTMLTableCellElement>;
        innerElRef?: Ref<HTMLDivElement>;
        bgContent: ComponentChildren;
        fgContentElRef?: Ref<HTMLDivElement>;
        fgContent: ComponentChildren;
        fgPaddingBottom: CssDimValue;
        hasEvents: boolean;
        moreCnt: number;
        moreMarginTop: number;
        showDayNumber: boolean;
        showWeekNumber: boolean;
        dateProfile: DateProfile;
        todayRange: DateRange;
        buildMoreLinkText: (num: number) => string;
        onMoreClick?: (arg: MoreLinkArg) => void;
        allFgSegs: TableSeg[];
        segIsHidden: {
            [instanceId: string]: boolean;
        };
    }
    export interface TableCellModel {
        key: string;
        date: DateMarker;
        extraHookProps?: object;
        extraDataAttrs?: object;
        extraClassNames?: string[];
    }
    export interface MoreLinkArg {
        date: DateMarker;
        allSegs: TableSeg[];
        hiddenSegs: TableSeg[];
        moreCnt: number;
        dayEl: HTMLElement;
        ev: UIEvent;
    }
    export interface HookProps {
        date: Date;
        isPast: boolean;
        isFuture: boolean;
        isToday: boolean;
    }
    export { TableCell as default, TableCell };
    class TableCell extends DateComponent<TableCellProps> {
        render(props: TableCellProps, state: {}, context: ComponentContext): h.JSX.Element;
        handleMoreLink: (ev: UIEvent) => void;
    }
}

declare module '@fullcalendar/daygrid/TableView' {
    import { VNode, h, ChunkContentCallbackArgs, DateComponent, ViewProps, RefObject } from '@fullcalendar/core';
    export { TableView as default, TableView };
    abstract class TableView<State = {}> extends DateComponent<ViewProps, State> {
        protected headerElRef: RefObject<HTMLTableCellElement>;
        renderSimpleLayout(headerRowContent: VNode | null, bodyContent: (contentArg: ChunkContentCallbackArgs) => VNode): h.JSX.Element;
        renderHScrollLayout(headerRowContent: VNode | null, bodyContent: (contentArg: ChunkContentCallbackArgs) => VNode, colCnt: number, dayMinWidth: number): h.JSX.Element;
    }
}

